<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Events</title>
    <script src="https://cdn.jsdelivr.net/npm/vue/dist/vue.js"></script>
</head>

<body>

    <!-- #Listening to Events -->

    <div id="ListeningEvent">
        <button v-on:click="counter += 1">Click +1</button>
        <p>The button above has been clicked {{ counter }} times.</p>
    </div>

    <script>
        var example1 = new Vue({
            el: '#ListeningEvent',
            data: {
                counter: 0
            }
        })
    </script>


    <!-- #Method Event Handlers -->
    <div id="example-2">
        <!-- `greet` is the name of a method defined below -->
        <button v-on:click="greet">Greet</button>
    </div>

    <script>var example2 = new Vue({
            el: '#example-2',
            data: {
                name: 'Vue.js'
            },
            // define methods under the `methods` object
            methods: {
                greet: function (event) {
                    // `this` inside methods points to the Vue instance
                    alert('Hello ' + this.name + '!')
                    console.log(this.name);
                    // `event` is the native DOM event
                    if (event) {
                        alert(event.target.tagName)
                        console.log(event.target.tagName);
                    }
                }
            }
        })

        // you can invoke methods in JavaScript too
        example2.greet() // => 'Hello Vue.js!'
    </script>

    <!-- #Methods in Inline Handlers -->
    <div id="example-3">
        <button v-on:click="say('hihihi')">Say hi</button>
        <button v-on:click="say('what123')">Say what</button>
    </div>

    <script>
        new Vue({
            el: '#example-3',
            methods: {
                say: function (message) {
                    alert(message)
                }
            }
        })
    </script>
<!-- #Event modifier -->
<!-- the click event's propagation will be stopped -->
<a v-on:click.stop="doThis"></a>

<!-- the submit event will no longer reload the page -->
<form v-on:submit.prevent="onSubmit"></form>

<!-- modifiers can be chained -->
<a v-on:click.stop.prevent="doThat"></a>

<!-- just the modifier -->
<form v-on:submit.prevent></form>

<!-- use capture mode when adding the event listener -->
<!-- i.e. an event targeting an inner element is handled here before being handled by that element -->
<div v-on:click.capture="doThis">...</div>

<!-- only trigger handler if event.target is the element itself -->
<!-- i.e. not from a child element -->
<div v-on:click.self="doThat">...</div>
</body>

</html>